/* Copyright (C) 2007 Alejandro Álvarez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef __CODEEDIT_H__
#define __CODEEDIT_H__

#include <QTextEdit>
#include <QMenu>
#include <QTextCursor>
#include "syntax.h"

class CodeEdit: public QTextEdit
{
  Q_OBJECT;
  bool auto_indent;

 protected:
  Syntax syntax;
  QMenu  contextMenu;

  void contextMenuEvent(QContextMenuEvent *e);
  bool event( QEvent * e );

 public slots:
  void undo();
  void redo();
  void deleteSelection();
  void toggleBreakpoint();

 public:
  CodeEdit(QWidget *parent = 0, QString syntaxF = QString());
  void setAutoindent(bool ai_ok);
  bool getAutoindent();

 signals:
  void toggleBreakpoint(int lineno);
};

#endif
